;This program will draw a 2D ladder front and side view
;as well as dimension the views.
;
;3-22-94
;Brigitte Robertson - Student
;Tim Urbaniak - Instructor 76264,2273
;Billings Vo-Tech
;3803 Central
;Billings, MT
;406-656-4445
;
;DR 238 Programming for CAD Applications - This program was an 
;assignment using the WHILE and IF commands (and their corresponding
;logic).  This program is placed into the public domain.
;
;            *** SUPPORT EDUCATION IN YOUR AREA ***
;
(DEFUN C:LADDER ()
  (SETVAR "CMDECHO" 0)
   (SETQ CL (GETVAR "CLAYER"))
   (SETVAR "BLIPMODE" 0)
(SETQ SW (GETDIST "\nWidth of stringer <0-2>: "))
   (IF (= SW NIL) (SETQ SW 2))
(SETQ ST (GETDIST "\nThickness of Stringer <0-1/2>: "))
   (IF (= ST NIL) (SETQ ST 0.5))
(SETQ RS (GETDIST "\nSize of Rung <0-3/4>: "))
   (IF (= RS NIL) (SETQ RS 0.75))
(SETQ LL (GETDIST "\nLength of Ladder <9-0>: "))
   (IF (= LL NIL) (SETQ LL 108))
(SETQ SP (GETPOINT "\nStart Point - Lower Left: "))
    (SETQ P1  (POLAR SP (DTR 90) LL))
    (SETQ P2  (POLAR P1 (DTR 0) ST))
    (SETQ P3  (POLAR P2 (DTR 270) LL))
    (SETQ P4  (POLAR P3 (DTR 0) 18))
    (SETQ P5  (POLAR P4 (DTR 0) ST))
    (SETQ P6  (POLAR P5 (DTR 90) LL))
    (SETQ P7  (POLAR P4 (DTR 90) LL))
    (SETQ P8  (POLAR P5 (DTR 0) 36))
    (SETQ P9  (POLAR P8 (DTR 90) LL))
    (SETQ P10 (POLAR P9 (DTR 0) SW))
    (SETQ P11 (POLAR P8 (DTR 0) SW))
        (COMMAND "LAYER" "M" "LADDER" "")  
        (COMMAND "LINE" SP P1 P2 P3 SP "")
        (COMMAND "LINE" P4 P5 P6 P7 P4 "")
        (COMMAND "LINE" P8 P9 P10 P11 P8 "")
    (SETQ HR (/ RS 2.0))  ;Half of Rung
    (SETQ A 12)
    (SETQ Z 1)
(WHILE Z
    (SETQ P12 (POLAR SP (DTR 90) A))
    (SETQ P13 (POLAR P12 (DTR 90) HR))
    (SETQ P14 (POLAR P12 (DTR 270) HR))
    (SETQ P15 (POLAR P14 (DTR 0) ST))
    (SETQ P16 (POLAR P15 (DTR 90) HR))
    (SETQ P17 (POLAR P16 (DTR 90) HR))
    (SETQ P18 (POLAR P17 (DTR 0) 18))
    (SETQ P19 (POLAR P18 (DTR 270) RS))
    (SETQ P20 (POLAR P19 (DTR 0) ST))
    (SETQ P21 (POLAR P20 (DTR 90) RS))
    (SETQ HSW (/ SW 2.0))           ;Half String Width
    (SETQ MID (+ ST 18 ST 36 HSW))  ;To Center of Donut
    (SETQ P22 (POLAR P12 (DTR 0) MID))
        (COMMAND "LINE" P13 P21 P20 P14 "")
        (COMMAND "SOLID" P13 P14 P17 P15 "")
        (COMMAND "DONUT" "0" HSW P22 "")
        (COMMAND "SOLID" P18 P19 P21 P20 "")
    (SETQ A (+ A 12))
(IF (OR (= A LL) (> A LL)) (SETQ Z NIL))
) 
        (COMMAND "LAYER" "M" "DIM" "C" "RED" "" "")
    (SETQ P5R (POLAR P5 (DTR 0) 4))
    (SETQ P8R (POLAR P8 (DTR 180) 4))
        (COMMAND "LINE" P8R P5R "")
    (SETQ P6R (POLAR P6 (DTR 0) 4))
    (SETQ P9R (POLAR P9 (DTR 180) 4))
        (COMMAND "LINE" P9R P6R "")
    (SETQ FT 12)
    (SETQ D1 (POLAR SP (DTR 90) FT))       ;Second extension line point
    (SETQ HST (/ ST 2.0))
    (SETQ P24 (POLAR P1 (DTR 0) HST))
    (SETQ TOP (DISTANCE P12 P24))
    (SETQ D2 (- (- LL FT) TOP))
    (SETQ DL1 (POLAR D1 (DTR 180) 10))      ;Point for dim line
    (SETQ DL2 (POLAR DL1 (DTR 180) 10))     ;Point for second dim line
     (SETQ UM (GETVAR "UNITMODE"))
     (SETVAR "UNITMODE" 0)
    (SETQ NTOP (RTOS TOP 4 2))
    (SETQ NFT (RTOS FT 4 2))
    (SETQ ND2 (RTOS D2 4 2))
    (SETQ NLL (RTOS LL 4 2))
     (SETQ DZ (GETVAR "DIMZIN"))
     (SETVAR "DIMZIN" 1)
        (COMMAND "DIM" "VERT" SP D1 DL1 NFT "CONT" P12 ND2 "CONT"  
         P1 NTOP "VERT" SP P1 DL2 NLL "E")
    (SETQ NST (RTOS ST 4 2))
    (SETQ MW 18)             ;Middle width between stringers
    (SETQ NMW (RTOS MW 4 2 ))
    (SETQ EE (+ ST ST 18))
    (SETQ NEE (RTOS EE 4 2))
    (SETQ DL3 (POLAR SP (DTR 270) 10))
    (SETQ DL4 (POLAR DL3 (DTR 270) 10))
        (COMMAND "DIM" "HOR" SP P3 DL3 NST "CONT" P4 NMW "CONT" P5 NST
         "HOR" SP P5 DL4 NEE "E")
    (SETQ NHSW (RTOS HSW 4 2))
    (SETQ NSW  (RTOS SW 4 2))
    (SETQ P23 (POLAR D1 (DTR 0) MID))
        (COMMAND "DIM" "HOR" P8 P23 DL3 NHSW "CONT" P11 NHSW
         "HOR" P8 P11 DL4 NSW "E")
        (COMMAND "LAYER" "S" CL "")
        (COMMAND "UNITMODE" UM)
        (COMMAND "DIMZIN" DZ)
)
(DEFUN DTR (A) (* PI (/ A 180.0)))
(DEFUN RTD (A) (/ (* A 180.0 PI)))
(PRINC "\nType LADDER to run - [will use current dimscale] ")
(PRINC)


